#include <platform.h>
#include "lcd.h"
#include "screen.h"
#include <print.h>
typedef	union{
	  unsigned char	 pixel_data[64 * 64 *2 + 1];
	  unsigned short pixel_data16[ 64*64];
	  unsigned  pixel_data32[ 64*64/2];
	} tPixels;
// logo exported by Gimp RGB16, just changed of the pixel type for tPixels.
#include "mylogo.h"

clock refClk = XS1_CLKBLK_REF;
in port midirx = XS1_PORT_1A;	//P1j0 X1D25
out port miditx = XS1_PORT_1B;  //P8D7,P16B15 X0D43
//lcd_ports lcdports = {  XS1_PORT_1G, XS1_PORT_1F, XS1_PORT_16A, XS1_PORT_1B, XS1_PORT_1C, XS1_CLKBLK_1};
lcd_ports lcdports = {  XS1_PORT_1I, XS1_PORT_1L, XS1_PORT_16B, XS1_PORT_1J, XS1_PORT_1K, XS1_CLKBLK_1 }; //Triangle

#define BACK_COLOUR (0xffffffff)
#define SPRITE_WIDTH_WORDS (gimp_image.width / gimp_image.bytes_per_pixel)
#define SPRITE_HEIGHT_PX (gimp_image.height)

static inline void add(unsigned x, unsigned y, unsigned line, unsigned buffer[]){
	if(line >= x && line < x + gimp_image.height)
		for(unsigned i=y;i<y + SPRITE_WIDTH_WORDS;i++)
			buffer[i] = gimp_image.pixels.pixel_data32[(line-x)*SPRITE_WIDTH_WORDS+(i-y)];
}

static inline void sub(unsigned x, unsigned y, unsigned line, unsigned buffer[]){
	if(line >= x && line < x + gimp_image.height)
		for(unsigned i=y;i<y + SPRITE_WIDTH_WORDS;i++)
			buffer[i] = BACK_COLOUR;
}

void demo(chanend c_lcd){
	unsigned buffer[3][LCD_ROW_WORDS]; //3rd buffer is for the text area only
	unsigned buffer_index = 0, update = 0;
	int x=20, y=0, vx=1, vy=2;
	for(unsigned i=0;i<LCD_ROW_WORDS;i++)
		buffer[0][i] = buffer[1][i] = buffer[2][i] =BACK_COLOUR;
	lcd_init(c_lcd);
	screen_init();
	screen_puts(0,0,"X:000 Y:00");
	screen_puts(20,0,"Hello World!");
	screen_puts(0,1,"This is the second line of the text area.");
	while(1){
		for(unsigned line=0;line<LCD_HEIGHT;line++){
			if (line < (TEXTAREAINPIXELS-1)){ //draw text area from scren buffer with chargen
				screen_line(line, buffer[2]);
				lcd_req(c_lcd);
				lcd_update(c_lcd, buffer[2]);
			}else{ //draw double buffered area line by line
				add(x, y, line, buffer[1 - buffer_index]);
				lcd_req(c_lcd);
				lcd_update(c_lcd, buffer[1 - buffer_index]);
				sub(x, y, line-1, buffer[buffer_index]);
				buffer_index = 1 - buffer_index;
			}
		}
		sub(x, y, LCD_HEIGHT-1, buffer[buffer_index]);
		if (update == 0) {//animation
			x += vx;
			y += vy;
			if (y <= 0) {
				vy = -vy;
				y = 0;
			}
			if (y >= LCD_ROW_WORDS - SPRITE_WIDTH_WORDS) {
				vy = -vy;
				y = LCD_ROW_WORDS - SPRITE_WIDTH_WORDS - 1;
			}
			if (x <= TEXTAREAINPIXELS) {
				vx = -vx;
				x = TEXTAREAINPIXELS;
			}
			if (x >= LCD_HEIGHT - SPRITE_HEIGHT_PX) {
				vx = -vx;
				x = LCD_HEIGHT - SPRITE_HEIGHT_PX - 1;
			}
		}else{ //update screen with coordinates
			screen_putc(10,0,'0'+x%10);
			screen_putc(9,0,'0'+x/10%10);
			screen_putc(8,0,'0'+x/100%10);
			screen_putc(4,0,'0'+y%10);
			screen_putc(3,0,'0'+y/10%10);
			screen_putc(2,0,'0'+y/100%10);
		}
		update = 1 - update;
	}
}

int main() {
  chan c_lcd;
  streaming chan c_min, c_mout;
  configure_out_port_no_ready(miditx, refClk, 1);
  configure_in_port_no_ready(midirx, refClk);
  clearbuf(midirx);
  par {
	lcd_server(c_lcd, lcdports);
	demo(c_lcd);
	par(int i=0;i<2;i++) while(1);
  }
  return 0;
}
